(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.immer = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
// @ts-check

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = produce;
exports.setAutoFreeze = setAutoFreeze;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PROXY_STATE = Symbol("immer-proxy-state"); // TODO: create per closure, to avoid sharing proxies between multiple immer version

var autoFreeze = true;

/**
 * Immer takes a state, and runs a function against it.
 * That function can freely mutate the state, as it will create copies-on-write.
 * This means that the original state will stay unchanged, and once the function finishes, the modified state is returned
 *
 * @export
 * @param {any} baseState - the state to start with
 * @param {Function} producer - function that receives a proxy of the base state as first argument and which can be freely modified
 * @returns {any} a new state, or the base state if nothing was modified
 */
function produce(baseState, producer) {
    // curried invocation
    if (arguments.length === 1) {
        var _producer = baseState;
        // prettier-ignore
        if (typeof _producer !== "function") throw new Error("if produce is called with 1 argument, the first argument should be a function");
        return function () {
            var args = arguments;
            return produce(args[0], function (draft) {
                args[0] = draft; // blegh!
                baseState.apply(null, args);
            });
        };
    }

    // prettier-ignore
    {
        if (arguments.length !== 2) throw new Error("produce expects 1 or 2 arguments, got " + arguments.length);
        if (!isProxyable(baseState)) throw new Error("the first argument to produce should be a plain object or array, got " + (typeof baseState === "undefined" ? "undefined" : _typeof(baseState)));
        if (typeof producer !== "function") throw new Error("the second argument to produce should be a function");
    }

    var finalizing = false;
    var finished = false;
    var descriptors = {};
    var states = [];

    var State = function () {
        function State(parent, proxy, base) {
            _classCallCheck(this, State);

            this.modified = false;
            this.hasCopy = false;
            this.parent = parent;
            this.base = base;
            this.proxy = proxy;
            this.copy = undefined;
        }

        _createClass(State, [{
            key: "get",
            value: function get(prop) {
                assertUnfinished();
                var value = this.source[prop];
                if (!finalizing && !isProxy(value) && isProxyable(value)) {
                    this.prepareCopy();
                    return this.copy[prop] = createProxy(this, value);
                }
                return value;
            }
        }, {
            key: "set",
            value: function set(prop, value) {
                assertUnfinished();
                if (!this.modified) {
                    if (this.source[prop] === value) return;
                    this.markChanged();
                }
                this.prepareCopy();
                this.copy[prop] = value;
            }
        }, {
            key: "markChanged",
            value: function markChanged() {
                if (!this.modified) {
                    this.modified = true;
                    if (this.parent) this.parent.markChanged();
                }
            }
        }, {
            key: "prepareCopy",
            value: function prepareCopy() {
                if (this.hasCopy) return;
                this.hasCopy = true;
                this.copy = Array.isArray(this.base) ? this.base.slice() : Object.assign({}, this.base);
            }
        }, {
            key: "source",
            get: function get() {
                return this.hasCopy ? this.copy : this.base;
            }
        }]);

        return State;
    }();

    // creates a proxy for plain objects / arrays


    function createProxy(parent, base) {
        var proxy = void 0;
        if (Array.isArray(base)) proxy = createArrayProxy(base);else proxy = createObjectProxy(base);
        var state = new State(parent, proxy, base);
        createHiddenProperty(proxy, PROXY_STATE, state);
        states.push(state);
        return proxy;
    }

    function createPropertyProxy(prop) {
        return descriptors[prop] || (descriptors[prop] = {
            configurable: true,
            enumerable: true,
            get: function get() {
                return this[PROXY_STATE].get(prop);
            },
            set: function set(value) {
                this[PROXY_STATE].set(prop, value);
            }
        });
    }

    function createObjectProxy(base) {
        var proxy = Object.assign({}, base);
        Object.keys(base).forEach(function (prop) {
            return Object.defineProperty(proxy, prop, createPropertyProxy(prop));
        });
        return proxy;
    }

    function createArrayProxy(base) {
        var proxy = new Array(base.length);
        for (var i = 0; i < base.length; i++) {
            Object.defineProperty(proxy, "" + i, createPropertyProxy("" + i));
        }return proxy;
    }

    function assertUnfinished() {
        if (finished) throw new Error("Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process?");
    }

    // this sounds very expensive, but actually it is not that extensive in practice
    // as it will only visit proxies, and only do key-based change detection for objects for
    // which it is not already know that they are changed (that is, only object for which no known key was changed)
    function markChanges() {
        // intentionally we process the proxies in reverse order;
        // ideally we start by processing leafs in the tree, because if a child has changed, we don't have to check the parent anymore
        // reverse order of proxy creation approximates this
        for (var i = states.length - 1; i >= 0; i--) {
            var state = states[i];
            if (state.modified === false) {
                if (Array.isArray(state.base)) {
                    if (hasArrayChanges(state)) state.markChanged();
                } else if (hasObjectChanges(state)) state.markChanged();
            }
        }
    }

    function hasObjectChanges(state) {
        var baseKeys = Object.keys(state.base);
        var keys = Object.keys(state.proxy);
        return !shallowEqual(baseKeys, keys);
    }

    function hasArrayChanges(state) {
        return state.proxy.length !== state.base.length;
    }

    function finalize(proxy) {
        // given a base object, returns it if unmodified, or return the changed cloned if modified
        if (!isProxy(proxy)) return proxy;
        var state = proxy[PROXY_STATE];
        if (state.modified === false) return state.base; // return the original target
        if (Array.isArray(proxy)) return finalizeArray(proxy);
        return finalizeObject(proxy);
    }

    function finalizeObject(proxy) {
        var res = Object.assign({}, proxy);
        Object.keys(res).forEach(function (prop) {
            res[prop] = finalize(res[prop]);
        });
        return freeze(res);
    }

    function finalizeArray(proxy) {
        return freeze(proxy.map(finalize));
    }

    // create proxy for root
    var rootClone = createProxy(undefined, baseState);
    // execute the thunk
    var maybeVoidReturn = producer(rootClone);
    //values either than undefined will trigger warning;
    !Object.is(maybeVoidReturn, undefined) && console.warn("Immer callback expects no return value. However " + (typeof maybeVoidReturn === "undefined" ? "undefined" : _typeof(maybeVoidReturn)) + " was returned");
    // and finalize the modified proxy
    finalizing = true;
    // find and mark all changes (for parts not done yet)
    markChanges();
    var res = finalize(rootClone);
    // make sure all proxies become unusable
    finished = true;
    return res;
}

function isProxy(value) {
    return !!value && !!value[PROXY_STATE];
}

function isProxyable(value) {
    if (!value) return false;
    if ((typeof value === "undefined" ? "undefined" : _typeof(value)) !== "object") return false;
    if (Array.isArray(value)) return true;
    var proto = Object.getPrototypeOf(value);
    return proto === proto === null || Object.prototype;
}

function freeze(value) {
    if (autoFreeze) {
        Object.freeze(value);
    }
    return value;
}

function createHiddenProperty(target, prop, value) {
    Object.defineProperty(target, prop, {
        value: value,
        enumerable: false,
        writable: true
    });
}

function shallowEqual(objA, objB) {
    //From: https://github.com/facebook/fbjs/blob/c69904a511b900266935168223063dd8772dfc40/packages/fbjs/src/core/shallowEqual.js
    if (Object.is(objA, objB)) return true;
    if ((typeof objA === "undefined" ? "undefined" : _typeof(objA)) !== "object" || objA === null || (typeof objB === "undefined" ? "undefined" : _typeof(objB)) !== "object" || objB === null) {
        return false;
    }
    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);
    if (keysA.length !== keysB.length) return false;
    for (var i = 0; i < keysA.length; i++) {
        if (!hasOwnProperty.call(objB, keysA[i]) || !Object.is(objA[keysA[i]], objB[keysA[i]])) {
            return false;
        }
    }
    return true;
}

/**
 * Automatically freezes any state trees generated by immer.
 * This protects against accidental modifications of the state tree outside of an immer function.
 * This comes with a performance impact, so it is recommended to disable this option in production.
 * It is by default enabled.
 *
 * @returns {void}
 */
function setAutoFreeze(enableAutoFreeze) {
    autoFreeze = enableAutoFreeze;
}
},{}]},{},[1])(1)
});